package com.pfc.Actividades;

// Esta clase es utilizada en el momento que le damos a algun nodo (ej: puente triana)
// y carga la foto y el mapa del nodo.
//es la actividad que muestra la informacin de una photo (entre esta informacin 
//muestra la localizacin)

import java.io.File;
import java.io.FileOutputStream;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import com.pfc.Actividades.R;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.pfc.Info.LibreGeoSocial;
import com.pfc.Info.Foto;
import com.pfc.Utilidades.Localizacion;

public class InfoFoto extends InfoNodo {
	
	private ImageView imagePhoto;
	private TextView lbTitle, lbBody, lbDate, lbDist, lbUploader;
	private ScrollView lbscroll;
	private Foto mPhoto;
	private String nameFile;

	
    public void onCreate(Bundle icicle) {
         super.onCreate(icicle);
         
         setContentView(R.layout.generic_card);
         
         OnClickListener showPhoto = new OnClickListener() {
       		public void onClick(View view) {
       			loadPhoto();
       		}
       	 };
         mPhoto = (Foto) mNode;  
         imagePhoto = (ImageView)this.findViewById(R.id.img);
         imagePhoto.setClickable(true);
         imagePhoto.setOnClickListener(showPhoto);

         lbscroll = (ScrollView) this.findViewById(R.id.ScrollView01);
         lbTitle = (TextView) this.findViewById(R.id.lbTitle);
         lbBody = (TextView) this.findViewById(R.id.lbBody);   
         lbDate = (TextView) this.findViewById(R.id.lbDate);
         lbDist = (TextView) this.findViewById(R.id.lbDist);
         lbUploader = (TextView) this.findViewById(R.id.lbUploader);

         lbTitle.setText (mPhoto.getName());
         lbBody.setText  (mPhoto.getDescription());
         lbDate.setText  ("Date: " + mPhoto.getSince().split(" ")[0]); 
         
         // Calcular distancia
         float dist = Localizacion.calculateDistance (ServicioLocalizacion.getCurrentLocation(),
        		 	mPhoto.getLocation());
         
         lbDist.setText  ("Distance: " + Localizacion.displayDistance(dist, Localizacion.AUTO));
         lbUploader.setText  ("by: " + mPhoto.getUsername());
         
         imagePhoto.setImageBitmap(mPhoto.getBitmapImageThumb()); 
         nameFile = mPhoto.getName().replace(" ", "_").replace("/","_").replace(".","_").replace(",","_");
         
         setIconId(R.drawable.image_48);
         showMap(mPhoto.getLongitude(), mPhoto.getLatitude());   
    }

    
	private void loadPhoto() {
		String tmp_path = getResources().getString(R.string.tmp_path);
		String name = mPhoto.getName();
		String url = mPhoto.getUrl();
				
		Bitmap bitmap = mPhoto.getBitmapImageMedium();

		File dirhandler = new File (tmp_path);
        if(! dirhandler.exists())
          dirhandler.mkdirs();

        try {
            FileOutputStream out = new FileOutputStream( tmp_path + "LGS_" + nameFile + ".jpeg");
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, out);
         	out.flush();
            out.close();
            } catch (Exception e) {
                    e.printStackTrace();
            }
		
    	Intent i = new Intent(android.content.Intent.ACTION_VIEW); 
    	i.setDataAndType(Uri.fromFile(new File(tmp_path + "LGS_" + nameFile + ".jpeg")), "image/jpeg");
    	startActivity(i);	
	}

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);        
        return true;
	}
}