package com.pfc.Actividades;

import java.lang.reflect.Method;
import java.util.Hashtable;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.ContextMenu;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.ViewGroup;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.AdapterContextMenuInfo;

import com.pfc.Actividades.R;
import com.pfc.Actividades.RealidadAumentada.VistaAR;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.pfc.Info.GeoNodo;
import com.pfc.Info.LibreGeoSocial;
import com.pfc.Info.Foto;
import com.pfc.Info.Usuario;
import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.Utilidades.Localizacion;

// Es la actividad encargada de mostrar la lista de nodos que le ha proporcionado
// el servidor

public class ListaNodos extends ListaGenerica implements OnClickListener {

	private static final int MENU_PRIVACY = Menu.FIRST + 20;
	private static final int MENU_LOCATION_PRIVACY = Menu.FIRST + 21;
	private static final int MENU_DELETE = Menu.FIRST + 22;
	private static final int MENU_SEE_MAP = Menu.FIRST + 23;
	private static final int DIALOG_FILTER = 11;
	private static final int DIALOG_PRIVACY = 13;
	private static final int DIALOG_LOCATION_PRIVACY = 14;
	private static final int DIALOG_NO_RESULTS = 15;
	public static final String LGS_RESOURCE = "lgs_resource";

	private NodeAdapter mAdapter = null;
	private Thread th = null;

	private static CapaGenerica mylayer = null;

	private String[] strCategories = null;
	private String[] strCategoriesFilter = null;

	private String mPrivacy = null;

	private static Bitmap layerBitmap;

	private Button prevButton;
	private Button nextButton;

	public void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);

		Log.e("NODELIST","onCreate - 4");
		// Get the layer
		Intent i = getIntent();
		mylayer = (CapaGenerica) i.getSerializableExtra("layer");

		// Reset pagination
		mylayer.resetPagination();

		// Adding generic menus for content		
		if (mylayer.getNameLayer().equalsIgnoreCase("lgs")){
			mylayer.setWriteable(true);
		}

		strCategories = mylayer.getCategories("id");
		
		if (mylayer.getId() != -1){
			strCategoriesFilter = new String[strCategories.length];
			for (int j=0; j< strCategories.length; j++){
				strCategoriesFilter[j] = "0";
			}
		}
		// Buttons to navigate
		prevButton = (Button) this.findViewById(R.id.btPrev);
		prevButton.setOnClickListener(this);

		nextButton = (Button) this.findViewById(R.id.btNext);
		nextButton.setOnClickListener(this);

		Log.e("Loading", "nodes are gonna be loaded");
		
		if (mNodeList == null || mNodeList.isEmpty())
			updateResources();
		else {
			setAdapter();
		}
		Log.e("Loading", "nodes updated");
	}

	public void onClick(View v) {

		if (prevButton.isPressed() && mylayer.getCurrentPage()==1)
		{
			Toast.makeText(getBaseContext(),
						"No hay pagina anterior!", 
						Toast.LENGTH_LONG).show();
		}
		else
		{
			if (prevButton.isPressed()) 
			{
				mylayer.previousPage();
				
			} else if (nextButton.isPressed()) 
			{
				mylayer.nextPage();
			}
	
			updateResources();
		}
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

		if ((mNodeList != null) && (keyCode == KeyEvent.KEYCODE_BACK))
			mNodeList.clear();

		GestorDato.getInstance().removeData(GestorDato.GENERIC_LAYER);
		GestorDato.getInstance().removeData(GestorDato.LAYER_CATEGORIES);

		return super.onKeyDown(keyCode, event);
	}

	private void updateResources() {

		if (mylayer.getId() == -1){
			CapaGenerica layer = (CapaGenerica) mylayer;
			th = layer.getThreadtoUpdate(handler_Adapter, strCategories);
			
		}else{
			String str[] = new String[strCategories.length];
			CapaGenerica layer = (CapaGenerica) mylayer;
			for (int i=0; i<strCategories.length; i++){
				if (strCategoriesFilter[i] == "x")
					str[i] = "x";
				else
					str[i] = strCategories[i];
			}
		
			th = layer.getThreadtoUpdate(handler_Adapter, str);
			
		}
		executePetition("Actualizando",
				"Descargando nodos...", th);
		
	}

	private Handler handler_Adapter = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			if (isFinishing())
				return;
			initAdapter();
		}
	};

	private void setAdapter() {
		if (mAdapter == null) {
			Log.e("ListaNodos: size=", String.valueOf(mNodeList.size()));

			mAdapter = new NodeAdapter(this);
			setListAdapter(mAdapter);

			// Init gestures
//			GesturesHandler gestureHand = new GesturesHandler();
//			gestureHand.initGestures(this, R.raw.gestures);

			Hashtable<Object, Object> htGestures = new Hashtable<Object, Object>();

			try {
				Class c = ListaNodos.class;
				Method m = c.getDeclaredMethod("GestureNext", (Class[]) null);
				Method m2 = c.getDeclaredMethod("GesturePrevious",
						(Class[]) null);

				htGestures.put((Object) "Previous", m);
				htGestures.put((Object) "Next", m2);

			} catch (NoSuchMethodException e) {
				e.printStackTrace();
			}

//			gestureHand.setGestures(htGestures);

		}
	}


	private void initAdapter() {
		Log.e("ListaNodos", "initAdapter");

		mNodeList = mylayer.getNodes();

		setAdapter();

		// Update the adapter
		mAdapter.notifyDataSetChanged();

		// Stop the thread
		th.stop();

		// Send message to close the progressDialog
		handler_PDialog.sendEmptyMessage(0);

		if (mNodeList.size()!=0)
		{
			// Show the page in the screen
			Toast.makeText(getBaseContext(),
					"Mostrando pagina " + mylayer.getCurrentPage(), 
					Toast.LENGTH_SHORT).show();
		}
		else
		{
			showDialog(DIALOG_NO_RESULTS);
		}
	}

	protected void onListItemClick(ListView l, View v, int position, long id) {

		GeoNodo myNode = mNodeList.get(position);

		if (Foto.class.isInstance(myNode)) {
			Intent i = new Intent(this, InfoFoto.class);
			i.putExtra("node", myNode);

			startActivity(i);
		} 
	}

	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View view,
			ContextMenuInfo menuInfo) {

		super.onCreateContextMenu(menu, view, menuInfo);
		
		if (mylayer.getWriteable()) {
			menu.add(0, MENU_PRIVACY, 0, "Privacy");
			menu.add(0, MENU_LOCATION_PRIVACY, 0, "Location perms");
			menu.add(0, MENU_DELETE, 0 , "Delete");
		}
	}
	


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		if (getIntent().getIntExtra("group", Integer.MIN_VALUE) == Integer.MIN_VALUE) {
			super.onCreateOptionsMenu(menu);
		}
		return true; 
	}


	public static class NodeAdapter extends BaseAdapter {

		private Context mContext;

		public NodeAdapter(Context c) {
			mContext = c;
		}

		public int getCount() {
			// TODO Auto-generated method stub
			return mNodeList.size();
		}

		public Object getItem(int position) {
			// TODO Auto-generated method stub
			return position;
		}

		public long getItemId(int position) {
			// TODO Auto-generated method stub
			return position;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			// TODO Auto-generated method stub
			View view;

			if (convertView == null) {
				// Make up a new view
				LayoutInflater inflater = (LayoutInflater) mContext
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				view = inflater.inflate(R.layout.generic_list, null);
			} else {
				// Use convertView if it is available
				view = convertView;
			}

			ImageView img = (ImageView) view.findViewById(R.id.image);

			GeoNodo myResource = mNodeList.get(position);
			String title = null;
			String description = null;

			// Calculate distance
			String distString = "";

			if (myResource.getLatitude() == -1.0
					&& myResource.getLongitude() == -1.0) {
				distString = "Unknow Location";
			} else if (ServicioLocalizacion.getCurrentLocation() == null)
				distString = "Unknow Location";
			else {
				// Calculate distance
				float dist = Localizacion.calculateDistance(ServicioLocalizacion
						.getCurrentLocation(), myResource.getLocation());

				distString = Localizacion.displayDistance(dist,
						Localizacion.AUTO);
			}

			// Layer icon

			if (Foto.class.isInstance(myResource)) {
				Foto myphoto = (Foto) mNodeList.get(position);
				img.setImageBitmap(myphoto.getBitmapImageThumb());
				title = myphoto.getName();
				description = "Dist: " + distString + "\n"
						+ myphoto.getDescription();

			} else if (Usuario.class.isInstance(myResource)) {

				Usuario myuser = (Usuario) mNodeList.get(position);
					img.setImageBitmap(myuser.getAvatarBitmap());

				title = myuser.getName() + " (" + myuser.getUsername() + ")";
				description = distString + " - " + myuser.getState();
			} 

			TextView t = (TextView) view.findViewById(R.id.title);
			t.setText(title);

			t = (TextView) view.findViewById(R.id.owner);
			t.setText(description);

			return view;
		}
	}
}
