package com.pfc.Actividades.RealidadAumentada;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.location.Location;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.PowerManager;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.Toast;
import com.pfc.Actividades.R;
import com.pfc.Actividades.GestorDato;
import com.pfc.Actividades.Rutas.IServicioLocalizacion;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.pfc.Info.LibreGeoSocial;
import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.SuperposicionesAR.CamaraPreview;
import com.pfc.SuperposicionesAR.DibujaFoco;
import com.pfc.SuperposicionesAR.DibujaRadar;
import com.pfc.Utilidades.Localizacion;

public class VistaAR extends ActividadAR{ 
	private static final int MENU_TAGGING = Menu.FIRST + 1;
	private static final int MENU_TAGGING_IMMEDIATE = MENU_TAGGING + 1;
	private static final int MENU_TAGGING_FAST = MENU_TAGGING_IMMEDIATE + 1;
	private static final int MENU_TAGGING_MAP = MENU_TAGGING_FAST + 1;
	private static final int MENU_TAGGING_ACCURATE_SIDE = MENU_TAGGING_MAP + 1;
	private static final int MENU_TAGGING_ACCURATE_LINE = MENU_TAGGING_ACCURATE_SIDE + 1;
	private static final int MENU_TAGGING_ANGLE = MENU_TAGGING_ACCURATE_LINE + 1;	
	private static final int MENU_DISTANCE_FILTER = MENU_TAGGING_ANGLE + 1;
	private static final int MENU_COMPASS_CORRECTION = MENU_DISTANCE_FILTER + 1;
	private static final int MENU_LOCATION = MENU_COMPASS_CORRECTION + 1;
	private static final int MENU_INDOOR_LOCATION = MENU_LOCATION + 1;
	private static final int MENU_SERVICE_LOCATION = MENU_INDOOR_LOCATION + 1;
	private static final int MENU_LOCATION_WAYS = MENU_SERVICE_LOCATION + 1;
	private static final int MENU_PREFERENCES = MENU_LOCATION_WAYS + 1;
	public static final int DIALOG_MOVE = 0;
	private static final int DIALOG_PBAR = 1;
	private static final int DIALOG_NOHEIGHT = 2;
	private static final int BIDI_LOC = 20;
	private static final int LOC_WAYS = 21;
	private static final int ACTION_NOHEIGHT = 0;
	private static final int ACTION_IGNORE = 1;
	private static final int ACTION_REQUEST = 2;
	private static VistaAR pointerObject = null;
	
	protected PowerManager.WakeLock mWakeLock;
	
    private CamaraPreview mPreview;
    private DibujaFoco mFocus;
    private DibujaRadar mRadar;  
    private int action = -1;
    
    private float cam_altitude;
    private float altitude;
//    private static float res_values[] = new float[3];
    private GestorBrujula compassManager;
    private int idGPS = -1;
    private static boolean showMenu = true;   
    private boolean refreshed;
    private boolean load_list = true;
    private static ARTagManager tagManager;   
    private String[] strCategories = null;
	
    
	private GestorBrujula.OnCompassChangeListener compassListener = new GestorBrujula.OnCompassChangeListener(){

		public void onChange(float[] values) {
			
			float[] values_new = values.clone();

			//THIS PART IS CRITICAL IN ORDER TO REFRESH THE VIEW!!!

			if(mRadar!=null){
				mRadar.setAzimuth(GestorBrujula.getAzimuth(values_new));
			}

			if (refreshed)
				refreshResourceDrawns(values_new);
			
			if(tagManager != null)
				tagManager.setAngles(values_new);
		}
		
	};
	
	OnClickListener distFiltClickListener = new OnClickListener() {
		
		public void onClick(View v) {
			refreshed = false;
			showMenu = true;
			
	//		getMyLayer().setRadius(CustomViews.getSeekbarValue());
    		getLayers().removeExtraElement((View) v.getParent());
    		getLayers().cleanResouceLayer();
			load_list = true;
			showResources();
		}
	};
	
    IServicioLocalizacion locationListener = new IServicioLocalizacion(){

		public void updateCurrentLocation(Location loc) {
			
			float[] location = {(float) loc.getLatitude(), (float) loc.getLongitude(), 0};
			setLocation(location);
			
			SharedPreferences sharedPreferences = 
				PreferenceManager.getDefaultSharedPreferences(VistaAR.this);
				if(tagManager.getSavingType() == -1)
//					altitude = (float) AltitudeManager.getAltitudeFromLatLong(getLocation()[0], getLocation()[1]);
//			cam_altitude = AltitudeManager.getAbsoluteAltitude(VistaAR.this, altitude, true);
			Localizacion.setUserHeight(cam_altitude);
			if(tagManager != null){
				tagManager.setUserLocation(location);
				tagManager.setCamAltitude(cam_altitude);
			}
		}
    	
    };
    
	
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        try {
        	
            pointerObject = this;
			refreshed = false;
        	
        	showMenu = true;
        	
			float[] location = new float[3];
			location[0] =  (float) ServicioLocalizacion.getCurrentLocation().getLatitude();
			location[1] = (float) ServicioLocalizacion.getCurrentLocation().getLongitude();
			setLocation(location);
			altitude = (float) ServicioLocalizacion.getCurrentLocation().getAltitude();
//			cam_altitude = AltitudeManager.getAbsoluteAltitude(getBaseContext(), altitude, true);
			Localizacion.setUserHeight(cam_altitude);
			
			// Hide the window title.
			requestWindowFeature(Window.FEATURE_NO_TITLE);
			
			// Create our Preview view and set it as the content of our activity.
			mPreview = new CamaraPreview(this);
			
			// setting the layers which we use as graphical containers
			getLayers().setBaseLayer();
//			layers.addBaseLayer(mPreview);
			getLayers().setInfoLayer();
			getLayers().setResourceLayer();
			getLayers().setExtraLayer();
			
			mFocus = new DibujaFoco(this);
			mRadar = new DibujaRadar(this);
			
			getLayers().addInfoElement(mRadar, null);
			getLayers().addInfoElement(mFocus, null);
			
			SharedPreferences sharedPreferences = 
				PreferenceManager.getDefaultSharedPreferences(VistaAR.this);
			
	//		getLayers().setMoveSummary(sharedPreferences.getBoolean(ARPreferences.KEY_MOVE_LABELS, false));
   
			final PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
			this.mWakeLock = pm.newWakeLock(PowerManager.SCREEN_BRIGHT_WAKE_LOCK, "My Tag");
			this.mWakeLock.acquire();
        	
			if(getMyLayer() == null)
				setMyLayer((CapaGenerica) GestorDato.getInstance().getData(GestorDato.GENERIC_LAYER));
			if(strCategories == null)
				strCategories = (String[]) GestorDato.getInstance().getData(GestorDato.LAYER_CATEGORIES);
			
			compassManager = new GestorBrujula(this);
			
			if (getMyLayer().getNodes() != null)
				load_list = false;
			
			tagManager = new ARTagManager(this, getLayers(), getMyLayer());
			tagManager.setSavingType(-1);
			tagManager.setUserLocation(getLocation());
			tagManager.setCamAltitude(cam_altitude);
			
		} catch (Exception e) {
			Log.e("PEDOR", "",e);
			Toast.makeText(getBaseContext(), 
					e.toString(), 
					Toast.LENGTH_LONG).show();
		}          
    }
    
    private void showResources(){
    	refreshed = false;

		getLayers().removeSummaryBox();

		setResourcesList(null);
    	if(!load_list){
    		
    		ArrayList<GeonodoAR> res_list;
    		
    		res_list = UtilidadesAR.cleanNoLocation(this, getLayers(), getMyLayer().getNodes());
    		
    		if(res_list == null){
    			Toast.makeText(getBaseContext(), 
    					"No resources available", 
    					Toast.LENGTH_LONG).show();
        		load_list = true;
        		return;
    		}
    		
    		if (res_list.size() > 50){
    			ArrayList<GeonodoAR> list = (ArrayList<GeonodoAR>) res_list.clone();
    			res_list.clear();
    			for(int i = 0; i < 50; i++)
    				res_list.add(list.get(i));
    			Toast.makeText(getBaseContext(), 
    					"Too many objects, showing the first 50 ones", 
    					Toast.LENGTH_LONG).show();
    		}
    		
    		ComparadorAzimuth comparator = new ComparadorAzimuth();
    		Collections.sort(res_list, comparator);
    		
    		setResourcesList(res_list);
    		
    		mRadar.setResourcesList(res_list);
    		
    		boolean no_height = false;
    		if(isUsingHeight())
    			no_height = UtilidadesAR.checkNoAltitudeInfo(res_list);
    		
    		load_list = true;
        	refreshed = true;
        	
        	if((no_height) && (action < 0))
        		showDialog(DIALOG_NOHEIGHT);
        	else{
        		switch(action){
        		case ACTION_NOHEIGHT:
        			useHeight(false);
        			break;
        		case ACTION_IGNORE:
        			break;
        		default:
        			break;
        		}
        	}
    	}else {
    		
    		showDialog(DIALOG_PBAR);
    		getMyLayer().getThreadtoUpdate (handlerEnd, strCategories).start();
    		
    	}
    }
	
    protected void onPause(){
    	super.onPause();
    	getLayers().removeBaseElement(mPreview);
    	compassManager.unregisterListeners();
    	if(!(idGPS<0))
    			ServicioLocalizacion.unRegisterLocationListener(idGPS);

		LibreGeoSocial.getInstance().setUserPosition((double) getLocation()[0], (double) getLocation()[1], (double) altitude);
		
		Location loc = new Location("Manual");
		loc.setLatitude(getLocation()[0]);
		loc.setLongitude(getLocation()[1]);
		loc.setAltitude(altitude);
		ServicioLocalizacion.setCurrentLocation(loc);
		
    }
    
    protected void onResume(){
    	super.onResume();
    	getLayers().addBaseLayer(mPreview);
    	refreshed = false;
    	showMenu = true;
    	
    	getLayers().cleanResouceLayer();
    	getLayers().cleanExtraLayer();
    	showResources();
    	compassManager.setOnCompassChangeListener(compassListener);
		
    	if(!(idGPS<0))
    		idGPS = ServicioLocalizacion.registerLocationListener(locationListener); 	
    }
    
    protected void onDestroy(){
    	
    	this.mWakeLock.release();
    	super.onDestroy();
    }
  
    
    
    @Override
    protected Dialog onCreateDialog(int id) {       
    	
    	switch (id) {
    	case DIALOG_PBAR:
    		ProgressDialog dialog = new ProgressDialog(this);
    		dialog.setMessage("Loading...");
    		dialog.setIndeterminate(true);
    		dialog.setCancelable(true);
    		return dialog;
    		
    	case DIALOG_NOHEIGHT:
    		return new AlertDialog.Builder(this)
    		.setTitle("Ayuda")
    		.setMessage("Ve girando el telefono hasta encontrar el punto que buscas")
			.setNegativeButton("Ok", new DialogInterface.OnClickListener() {
				
				public void onClick(DialogInterface dialog, int which) {
					action = ACTION_IGNORE;
				}
			})
			.create();
    		
    	case DIALOG_MOVE:

    		LayoutInflater factory1 = LayoutInflater.from(this);
  //  		final View textEntryView1 = factory1.inflate(R.layout.dialog_movement, null);

    		OnClickListener moveStraightListener = new OnClickListener(){
    			
    			public void onClick(View v) {
    				setLocation(Localizacion.moveTo(tagManager.getUserLocation(), GestorBrujula.getAzimuth(tagManager.getAngles()), 
    						Localizacion.MOVE_STRAIGHT, 1));

    				tagManager.setUserLocation(getLocation());
    				dismissDialog(DIALOG_MOVE);
    			}

    		};

    		OnClickListener moveRightListener = new OnClickListener(){
    			
    			public void onClick(View v) {
    				setLocation(Localizacion.moveTo(tagManager.getUserLocation(), GestorBrujula.getAzimuth(tagManager.getAngles()), 
    						Localizacion.MOVE_RIGHT, 1));

    				tagManager.setUserLocation(getLocation());
    				dismissDialog(DIALOG_MOVE);
    			}

    		};

    		OnClickListener moveBackListener = new OnClickListener(){
    			
    			public void onClick(View v) {
    				setLocation(Localizacion.moveTo(tagManager.getUserLocation(), GestorBrujula.getAzimuth(tagManager.getAngles()), 
    						Localizacion.MOVE_BACK, 1));

    				tagManager.setUserLocation(getLocation());
    				dismissDialog(DIALOG_MOVE);
    			}

    		};

    		OnClickListener moveLeftListener = new OnClickListener(){
    			
    			public void onClick(View v) {
    				setLocation(Localizacion.moveTo(tagManager.getUserLocation(), GestorBrujula.getAzimuth(tagManager.getAngles()), 
    						Localizacion.MOVE_LEFT, 1));

    				tagManager.setUserLocation(getLocation());
    				dismissDialog(DIALOG_MOVE);
    			}

    		};
/*
    		Button btnStraight = (Button) textEntryView1.findViewById (R.id.btMoveStraight);
    		btnStraight.setClickable(true);
    		btnStraight.setOnClickListener(moveStraightListener);

    		Button btnBack = (Button) textEntryView1.findViewById (R.id.btMoveBack);
    		btnBack.setClickable(true);
    		btnBack.setOnClickListener(moveBackListener);

    		Button btnLeft = (Button) textEntryView1.findViewById (R.id.btMoveLeft);
    		btnLeft.setClickable(true);
    		btnLeft.setOnClickListener(moveLeftListener);

    		Button btnRight = (Button) textEntryView1.findViewById (R.id.btMoveRight);
    		btnRight.setClickable(true);
    		btnRight.setOnClickListener(moveRightListener);

    		if(idGPS!=-1){
    			btnLeft.setVisibility(View.INVISIBLE);
    			btnRight.setVisibility(View.INVISIBLE);
    			btnStraight.setVisibility(View.INVISIBLE);
    			btnBack.setVisibility(View.INVISIBLE);
    		}

    		if(tagManager.getSavingType() == ARTagManager.TAG_ACCURATE_LINE){
    			btnLeft.setVisibility(View.INVISIBLE);
    			btnRight.setVisibility(View.INVISIBLE);

    		}else{
    			btnStraight.setVisibility(View.INVISIBLE);
    			btnBack.setVisibility(View.INVISIBLE);
    		}
*/
    		return new AlertDialog.Builder(this)	      
    		.setCancelable(false)
    		.setTitle("Move for tagging")
   // 		.setView(textEntryView1)
    		.setPositiveButton("Done", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int whichButton) {

    				/* Usuario clicked OK so do some stuff */ 
    				showMenu = true;
    				getLayers().cleanExtraLayer();
    //				tagManager.launchResult();
    				removeDialog(DIALOG_MOVE);

    			}
    		})
    		.setNeutralButton("Skip", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int whichButton) {

    			}
    		})
    		.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int whichButton) {

    				/* Usuario clicked OK so do some stuff */ 
    				showMenu = true;
    				tagManager.setSavingType(-1);

    				getLayers().cleanExtraLayer();
    				removeDialog(DIALOG_MOVE);
    			}
    		})
    		.create();
    	}
		return null;
    
	}
    
    private void actionRequestHeight(){
    	final Handler handler = new Handler(){
			@Override
			public void handleMessage(Message msg) {
				refreshed = true;
				removeDialog(DIALOG_PBAR);
			}
		};
		refreshed = false;
		removeDialog(DIALOG_NOHEIGHT);
		useHeight(true);
		showDialog(DIALOG_PBAR);
		new Thread(){
			public void run(){
				updateHeights();
				handler.sendEmptyMessage(0);
			}
		}.start();
    }

	
	private Handler handlerEnd = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			if(VistaAR.this.isFinishing())
				return;
			load_list = false;
			showResources();
			removeDialog(DIALOG_PBAR);
		}
	};
	

	public static void GestureNext ()
	{		
		if (pointerObject == null)
			return;
		
		GestorCapa layers = pointerObject.getLayers();
		int num_click = layers.getNodeClicked();
		if(num_click < 0)
			return;
		int fixed_num = num_click;
		do{
			num_click++;
			if(num_click >= pointerObject.getResourcesList().size())
				num_click = 0;
			if(fixed_num == num_click)
				break;
		}while(!pointerObject.getResourcesList().get(num_click).getDrawn().forceClick());
		
		Log.e("Gesture", "NEXT " + Integer.toString(num_click));
		return ;
		
	}
	
	public static void GesturePrevious ()
	{	
		if (pointerObject == null)
			return;
		
		GestorCapa layers = pointerObject.getLayers();
		int num_click = layers.getNodeClicked();
		if(num_click < 0)
			return;
		int fixed_num = num_click;
		do{
			num_click--;
			if(num_click < 0)
				num_click = pointerObject.getResourcesList().size() - 1;
			if(fixed_num == num_click)
				break;
		}while (!pointerObject.getResourcesList().get(num_click).getDrawn().forceClick());
		
		Log.e("Gesture", "PREVIOUS " + Integer.toString(num_click));
		return;
	}
}
