package com.pfc.Actividades.Rutas;

import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.ListPreference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceCategory;
import android.preference.PreferenceScreen;
import android.util.Log;

import com.pfc.Actividades.R;

// Esta clase es utilizada cuando se esta ejecutando la "Realidad aumentada" en la 
// pantalla del movil. 

public class PreferenciasRuta extends PreferenceActivity 
{
	public static String KEY_LOCATION_PROVIDERS  = "ROUTE_location_providers";
	public static String KEY_LOCATION_UNITS 	 = "ROUTE_location_unit";
	public static String KEY_LOCATION_PERIODIC   = "ROUTE_location_periodic";
	public static String KEY_LOCATION_MANUAL     = "ROUTE_location_manual";
	public static String KEY_LOCATION_DISTANCE	 = "ROUTE_location_distance";	
	public static String KEY_LOCATION_WRITERMODE = "ROUTE_location_writermode";
	public static String KEY_LOCATION_SERVICE    = "ROUTE_location_service";
	
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setPreferenceScreen(createPreferenceHierarchy());
    }

    private PreferenceScreen createPreferenceHierarchy() {
        PreferenceScreen root = getPreferenceManager().createPreferenceScreen(this);

        PreferenceCategory dialogBasedPrefCat = new PreferenceCategory(this);
        dialogBasedPrefCat.setTitle("Location (service)");
        root.addPreference(dialogBasedPrefCat);
        
        CheckBoxPreference servicePref = new CheckBoxPreference(this);
        servicePref.setKey(KEY_LOCATION_SERVICE);
        servicePref.setTitle("Active Location Service");
        servicePref.setSummary("The service runs ever if the app is closed");
        dialogBasedPrefCat.addPreference(servicePref);
        
        ListPreference listPref = new ListPreference(this);
        listPref.setEntries(R.array.location_methods);
        listPref.setEntryValues(R.array.valueslocation_methods);
        listPref.setDialogTitle("Location Providers");
        listPref.setKey(KEY_LOCATION_PROVIDERS);
        listPref.setTitle("Location provider");
        listPref.setSummary("Choose the provider for your location");
        dialogBasedPrefCat.addPreference(listPref);
        
        ListPreference listPrefUnits = new ListPreference(this);
        listPrefUnits.setEntries(R.array.location_units);
        listPrefUnits.setEntryValues(R.array.valueslocation_units);
        listPrefUnits.setDialogTitle("Location Units");
        listPrefUnits.setKey(KEY_LOCATION_UNITS);
        listPrefUnits.setTitle("Time units");
        listPrefUnits.setSummary("Choose the time unit");
        dialogBasedPrefCat.addPreference(listPrefUnits);
        
        ListPreference listPrefPeriodic = new ListPreference(this);
        listPrefPeriodic.setEntries(R.array.location_periodic);
        listPrefPeriodic.setEntryValues(R.array.location_periodic);
        listPrefPeriodic.setDialogTitle("Location Periodic");
        listPrefPeriodic.setKey(KEY_LOCATION_PERIODIC);
        listPrefPeriodic.setTitle("Time periodic");
        listPrefPeriodic.setSummary("Choose the time periodic");
        dialogBasedPrefCat.addPreference(listPrefPeriodic);
        
        // List minimum distance
        ListPreference listPrefDistance = new ListPreference(this);
        listPrefDistance.setEntries(R.array.values_minimumdistance);
        listPrefDistance.setEntryValues(R.array.values_minimumdistance);
        listPrefDistance.setDialogTitle("Minimum Distance");
        listPrefDistance.setKey(KEY_LOCATION_DISTANCE);
        listPrefDistance.setTitle("Minimum Distance");
        listPrefDistance.setSummary("Choose the minimum distance gps refresh");
        dialogBasedPrefCat.addPreference(listPrefDistance);

        return root;
    }
}
