package com.pfc.Info;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Serializable;
import java.util.ArrayList;

import com.pfc.Utilidades.MapaBit;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;

public class Usuario extends GeoNodo implements Serializable {

	// Serializable UID
	private static final long serialVersionUID = -9121943636715457236L;
	
	private String  mName;	
	private String  mLastName;
	private String  mUsername;
	private String  mEmail;
	private String  mStatus;
	private String  mStatus_since;
	private String  mPassword;
	
	private ArrayList<Usuario> mFriends;
	private String mGroups;
	private String mPhotos;
	
	private String mCountry;
	private Integer mPostCode;
	private String mBirthday;
	
	private Integer mAvatarId;
	private String mAvatarUrl;
	
	byte[]  mByteBitMapAvatar;
	
	
	public Usuario (Integer id, String name, String lastName, String username, String email, String state,
			     Double latitude, Double longitude, Double altitude, Double radius, String since,
			     String country, Integer postCode, String birthday, ArrayList<Usuario> friends, Integer avatarId, String avatarUrl, String status_since,
			     String position_since)
	{
		super(id,latitude,longitude,altitude,radius,since,position_since);
		Log.e("YYYYYYYY5","YYYYYYYYY5");

		mName = name;
		mUsername = username;
		mEmail = email;
		mStatus = state;
		mStatus_since = status_since;
	
		mFriends = friends;
		
		mCountry = country;
		mPostCode = postCode;
		mBirthday = birthday;
		
		mLastName = lastName;
		
		mAvatarId = avatarId;
		mAvatarUrl = avatarUrl;
		
		mByteBitMapAvatar=null;
		
	}
	

	public String getName() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mName;
	}
	public String getLastName() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mLastName;
	}
	public String getUsername() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mUsername;
	}
	public String getEmail() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mEmail;
	}
	public String getState() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mStatus;
	}

	public ArrayList<Usuario> getFriends()
	{
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mFriends;
	}
	
	public String getPassword()
	{
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mPassword;
	}
	
	public void setPassword (String password)
	{
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		mPassword = password;
	}


	public String getCountry() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mCountry;
	}


	public void setCountry(String country) {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		mCountry = country;
	}


	public Integer getPostCode() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mPostCode;
	}


	public void setPostCode(Integer postCode) {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		mPostCode = postCode;
	}


	public String getBirthday() {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mBirthday;
	}


	public void setBirthday(String birthday) {
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		mBirthday = birthday;
	}
	
	public String getAvatarUrl()
	{
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mAvatarUrl;
	}
	
	public Integer getAvatarId()
	{
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		return mAvatarId;
	}
	
	public Bitmap getAvatarBitmap ()
	{
		Log.e("YYYYYYYY5","YYYYYYYYY5");
		if (getAvatarId()==null)
			return null;
		
		Bitmap bitmapImage = null;
		
		if (mByteBitMapAvatar == null)
		{
			Log.e("AVATAR",getAvatarUrl());
			
			bitmapImage = LibreGeoSocial.getInstance().getBitmap("layer/42124/node/" + getAvatarId().toString() + "/image/small/");
			
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			
			if (!bitmapImage.compress(Bitmap.CompressFormat.JPEG, 100, baos))
			{
				Log.e("getAvatarBitmap","Error: Don't compress de image");
				return null;
			}
			mByteBitMapAvatar = baos.toByteArray();
			
		}
		
		return BitmapFactory.decodeStream( new ByteArrayInputStream( mByteBitMapAvatar) );
		
	}
}

