package com.pfc.SuperposicionesAR;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;

// Esta clase, que hereda de la clase View, define la representacion de un 
// pequeo foco situado en la pantalla.

public class DibujaFoco extends View{

	public static final int CENTER = 0;
	public static final int SIDE = 1;	
	private static final float fRADIUS = 5;
	private int position = CENTER;
	
	public DibujaFoco(Context context) {
		super(context);
	}
	
	@Override
	protected void onDraw(Canvas canvas){
		
		Paint paint = new Paint();
		paint.setStyle(Paint.Style.FILL);
		paint.setColor(Color.WHITE);
		paint.setFakeBoldText(true);
		
		int w = canvas.getWidth();
        int h = canvas.getHeight();
        float cx;
        float cy;
        
        switch (position){
        
        case CENTER:
            cx = ((float)w) / 2 ;
            cy = ((float)h) / 2 - 12.5f ;
            break;
            
        case SIDE:
        	cx = ((float)w) / 4;
            cy = ((float)h) / 2 ;
        	break;
        	
        default:
        	cx = 0;
        	cy = 0;
        }

		paint.setStyle(Paint.Style.STROKE);
		canvas.drawCircle(cx, cy, fRADIUS, paint);		
		super.onDraw(canvas);
	}
}