package com.pfc.Utilidades;

import android.util.Log;

//Clase utilizada cuando le damos a "Mostrar en AR" para ver el giro del telefono

public class ControladorBrujula{
	
	private float Kp, Kd, Ki;
	private float last_value = 0; 
	private float integral = 0;
	private double last_error = 0;
	private boolean complex = false;
	
	
	public ControladorBrujula(float Kp, boolean complex){
		this.Kp = Kp;
		this.complex = complex;
	}
	
	
	public float getValue(float new_value){
		float error = new_value - last_value;
		if (error > 180)
			error = error - 360;
		else if (error < (-180))
			error = error + 360;
		
		float K = Kp;
		if (complex){
			if(Math.abs(error) <10){
				double calc = Math.pow(11-Math.abs(error), 2);
				K = (float) (((calc-1)/Math.pow(2, last_error) + 1) * 1/calc) * Kp;
				if(Math.abs(error) < 3)
					last_error = Math.min(20, last_error + 1);
				else
					last_error = Math.max(0, last_error - 0.5);
			}else
				last_error = 0;
		}
		
		float value = K * error;
		
		value += last_value;
		if(value > 360)
			value = value - 360;
		else if(value < 0)
			value = 360 + value;
		
		last_value = value;
		return value;
	}
}